%define	jail	/var/chroot/named
%define bind_share_dir /usr/share/bind

Summary:	BIND -- The Berkeley Internet Name Domain DNS Server
Name:		bind
Group:		Networking/Daemons
License:	BSD-ish
Version:	9.3.1
Release:	8
Source0:	ftp://ftp.isc.org/isc/bind9/%{version}/bind-src-%{version}.tar.gz
Source1:	bind-chroot-9.3.1-1.jail.tar.gz
Source3:	named.init-gd-3
Source4:	named.root-2004012900
Source5:	rndc.conf-gd2
Source6:	named-upgrade-3.0.pl.2
Patch0:		bind-9.3.1-named.conf-rndc-fixes-0000898-gd-2.diff
Requires:	initscripts >= 6.3
Obsoletes:	bind-chroot
Provides:	bind-chroot
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root

%description
Includes the named name server, which is used to define host name to
IP address translations (and vice versa).  It can be used on
workstations as a caching name server, but is generally only needed on
one machine for an entire network.

%files
  %defattr(0444,root,root,0555)
  %doc src/README src/CHANGES

  %attr(0500,root,root)		%{_sbindir}/dnssec-keygen
  %attr(0500,root,root)		%{_sbindir}/dnssec-signzone
  %attr(0500,root,root)		%{_sbindir}/lwresd
  %attr(0500,root,root)		%{_sbindir}/named
  %attr(0500,root,root)		%{_sbindir}/named-checkconf
  %attr(0500,root,root)		%{_sbindir}/named-checkzone
  %attr(0500,root,root)		%{_sbindir}/rndc
  %attr(0500,root,root)		%{_sbindir}/rndc-confgen

  %attr(0500,root,root)		%{bind_share_dir}/named-upgrade-3.0.pl

  %attr(700,root,root)		%{_sysconfdir}/init.d/named
  %attr(0640,root,named)	%config(noreplace) %{_sysconfdir}/rndc.conf

  %attr(0666,root,root)		%{jail}/dev/null
  %attr(0644,root,root)		%{jail}/%{_prefix}/lib/zoneinfo/*

  %attr(0644,named,root)	%{jail}/%{_sysconfdir}/named.conf
  %attr(0644,named,root)	%config(noreplace) %{jail}/%{_sysconfdir}/group
  %attr(0644,named,root)	%config(noreplace) %{jail}/%{_sysconfdir}/localtime

  %attr(0700,named,named)	%{jail}/%{_var}/log
  %attr(0700,named,named)	%{jail}/%{_var}/named/master
  %attr(0700,named,named)	%{jail}/%{_var}/named/slave
  %attr(0600,named,root)	%config(noreplace) %{jail}/%{_var}/named/named.conf
  %attr(0600,named,root)	%config %{jail}/%{_var}/named/named.root
  %attr(0600,named,root)	%config %{jail}/%{_var}/named/named.run
  %attr(0700,named,named)	%{jail}/%{_var}/run
  %attr(0700,named,named)	%{jail}/%{_var}/tmp

%package -n libbind
Summary:	BIND shared libraries.
Group:		System Environment/Libraries

%description -n libbind
This package contains the runtime shared libraries for the BIND
DNS server.

%files -n libbind
  %defattr(0444,root,root,0555)
  %doc %{_mandir}/man?/*

  %attr(0555,root,root)		%{_libdir}/*.so.*

%package -n libbind-devel
Summary:	Static libraries and header files for BIND.
Group:		Development/Libraries
Requires:	libbind = %{version}-%{release}

%description -n libbind-devel
This package contains the header files and static libraries for
the BIND DNS server.

%files -n libbind-devel
  %defattr(0444,root,root,0555)
  %doc %{_mandir}/man?/*

  %attr(0444,root,root)		%{_includedir}/*.h
  %attr(0444,root,root)		%{_includedir}/*/*.h
  %attr(0444,root,root)		%{_libdir}/*.a
  %attr(0444,root,root)		%{_libdir}/*.la
  %attr(0555,root,root)		%{_libdir}/*.so

%package utils
Summary:	DNS utils - host, dig, dnsquery, nslookup
Group:		Networking/Utilities
Obsoletes:	bind-chroot-utils
Provides:	bind-chroot-utils
Requires:	libbind = %{version}-%{release}

%description utils
Collection of utilities for querying name servers and looking up
hosts.  These tools let you determine the IP addresses for given host
names, and find information about registered domains and network
addresses.

%files utils
  %defattr(0444,root,root,0555)

  %attr(0511,root,root)		%{_bindir}/dig
  %attr(0511,root,root)		%{_bindir}/host
  %attr(0511,root,root)		%{_bindir}/isc-config.sh
  %attr(0511,root,root)		%{_bindir}/nslookup
  %attr(0511,root,root)		%{_bindir}/nsupdate

%prep
pwd
%setup -q -c -n %{name}-%{version}-%{release} -T -a 0 -a 1
%patch0 -p1

%build
  pushd src
    %configure \
	--localstatedir=/var \
	--enable-ipv6 \
	--enable-largefile \
	--enable-libbind \
	--enable-threads \
	--with-openssl=/usr \
	--with-libtool \
	--with-pic

    make %{?_smp_mflags}
  popd

%install
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

  install -d $RPM_BUILD_ROOT/%{_sysconfdir}/init.d

  pushd src
    %makeinstall
  popd

  # Install our chroot jail environment.
  mkdir -p $RPM_BUILD_ROOT/%{jail}
  cp -av jail/* $RPM_BUILD_ROOT/%{jail}

  # Install our initscript.
  install %{SOURCE3} $RPM_BUILD_ROOT/%{_sysconfdir}/init.d/named
  install %{SOURCE4} $RPM_BUILD_ROOT/%{jail}/var/named/named.root
  install %{SOURCE5} $RPM_BUILD_ROOT/%{_sysconfdir}/rndc.conf

  # Install bind 9 upgrade script
  mkdir -p $RPM_BUILD_ROOT/%{bind_share_dir}
  install %{SOURCE6} $RPM_BUILD_ROOT/%{bind_share_dir}/named-upgrade-3.0.pl

  # These includes are part of glibc.
  rm -f  $RPM_BUILD_ROOT/%{_includedir}/arpa/inet.h
  rm -f  $RPM_BUILD_ROOT/%{_includedir}/arpa/nameser.h
  rm -f  $RPM_BUILD_ROOT/%{_includedir}/arpa/nameser_compat.h
  rm -f  $RPM_BUILD_ROOT/%{_includedir}/net/route.h
  rm -f  $RPM_BUILD_ROOT/%{_includedir}/netdb.h
  rm -f  $RPM_BUILD_ROOT/%{_includedir}/resolv.h

%pre
  if [ "$1" = 1 ]; then
	/usr/sbin/adduser -r named || :;
  fi

%post
  # Upgrade
  if [ "$1" = 2 ]; then 
    /usr/share/bind/named-upgrade-3.0.pl 
  fi
 
  # Create rndc.key if non-existent
  if [ ! -f /var/chroot/named/etc/rndc.key ]; then
     rndc-confgen -a -b 512 -c /var/chroot/named/etc/rndc.key
     chown root.named /var/chroot/named/etc/rndc.key
     chmod 640 /var/chroot/named/etc/rndc.key
  fi

  cd %{jail}/dev
  cd ../etc
  grep '^named:' /etc/group > ./group
  cp /etc/localtime ./localtime

  if [ -f /var/lock/subsys/named ]; then
	/etc/init.d/named restart || :;
  fi

%preun
  if [ "$1" = 0 ]; then
	/etc/init.d/named stop  || :;
	/sbin/chkconfig --del named || :;
  fi

%clean
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%changelog
* Fri Sep 23 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 9.3.1, Release 8
  - Fix the key stuff in rndc.conf and move to /etc.
  - Tighten the permissions on rndc.key.
  - Add our "controls" directive to named.conf, and include rndc.key.
  - Remove all of the BIND 8 patches that we don't apply anymore.

* Thu Sep 08 2005 Peter J. O'Hara <pete@guardiandigital.com>
- Version 9.3.1, Release 7
  - Created a new jail tarball for 9.3.1

* Wed Sep 01 2005 Peter J. O'Hara <pete@guardiandigital.com>
- Version 9.3.1, Release 6
  - Fixed $ORIGIN bug in upgrade script
  - Moved upgrade script to /usr/share/bind

* Wed Aug 31 2005 Peter J. O'Hara <pete@guardiandigital.com>
- Version 9.3.1, Release 5
  - Added %post script to upgrade from bind 8
  - Generate rndc.key in %post

* Wed Aug 24 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 9.3.1, Release 4
  - Fix dependancies.

* Tue Jul 26 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 9.3.1, Release 3
  - Don't use %{_libdir} in the chroot.

* Fri Jul 08 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 9.3.1, Release 2
  - Rebuild against openssl-0.9.8.
  - Remove some includes which clash with glibc.

* Tue Jun 28 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 9.3.1, Release 1
  - Initial build for EnGarde Secure Linux 3.0.
